function [ r_final,u_final,E_final ] = RK_solving_Euler(r,u,E,rLim,uLim,ELim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
Globals1D;
 ParametersPhysic;

r_final=zeros(P+1,N);
u_final=zeros(P+1,N);
E_final=zeros(P+1,N);
RK_total_step=P+1;
switch RK_total_step
    case 1, [ r_final,u_final,E_final ]=RK_First_Order_Euler(r,u,E,rLim,uLim,ELim,dt);
    case 2, [ r_final,u_final,E_final ]=RK_Second_Order_Euler(r,u,E,rLim,uLim,ELim,dt);
    case 3, [ r_final,u_final,E_final ]=RK_Third_Order_Euler(r,u,E,rLim,uLim,ELim,dt);   
    otherwise [ r_final,u_final,E_final ]=RK_Third_Order_Euler(r,u,E,rLim,uLim,ELim,dt);   
end


end

function [r_1,u_1,E_1 ] = RK_First_Order_Euler(r,u,E,rLim,uLim,ELim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;  
  ParametersPhysic;
 
r_1=zeros(P+1,N);
u_1=zeros(P+1,N);
E_1=zeros(P+1,N);
flux_r=zeros(P+1,N);
flux_ru=zeros(P+1,N);
flux_E=zeros(P+1,N);

[rLim, uLim, ELim]=BC_Euler(r,u,E);
[flux_r, flux_ru, flux_E]=Solvers_Euler(r,u,E,rLim,uLim,ELim);
 
  
r_1=r+dt*flux_r;
u_1=r.*u+dt*flux_ru;
u_1=u_1./r_1;

E_1=E+dt*flux_E;


end

function [r_2,u_2,E_2 ] = RK_Second_Order_Euler(r,u,E,rLim,uLim,ELim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;   
 ParametersPhysic;
 
r_1=zeros(P+1,N);
u_1=zeros(P+1,N);
E_1=zeros(P+1,N);
r_2=zeros(P+1,N);
u_2=zeros(P+1,N);
E_2=zeros(P+1,N);

flux_r=zeros(P+1,N);
flux_ru=zeros(P+1,N);
flux_E=zeros(P+1,N);

[rLim, uLim, ELim]=BC_Euler(r,u,E);
[flux_r, flux_ru, flux_E]=Solvers_Euler(r,u,E,rLim,uLim,ELim);
 
  
r_1=r+dt*flux_r;
u_1=r.*u+dt*flux_ru;
u_1=u_1./r_1;

E_1=E+dt*flux_E;

[rLim, uLim, ELim]=BC_Euler(r_1,u_1,E_1);

if(slope == 1)   
    u_1=SlopelimitN(r_1.*u_1,rLim.*uLim );
    r_1=SlopelimitN(r_1,rLim);
    u_1=u_1./r_1;
    E_1=SlopelimitN(E_1,ELim);  
end


[flux_r, flux_ru, flux_E]=Solvers_Euler(r_1,u_1,E_1,rLim,uLim,ELim);
 
  
r_2=0.5*(r+r_1)+0.5*dt*flux_r;
u_2=0.5*(r.*u+r_1.*u_1)+0.5*dt*flux_ru;
u_2=u_2./r_2;

E_2=0.5*(E+E_1)+0.5*dt*flux_E;

[rLim, uLim, ELim]=BC_Euler(r_2,u_2,E_2);

if(slope == 1) 
    u_2=SlopelimitN(r_2.*u_2,rLim.*uLim );
    r_2=SlopelimitN(r_2,rLim );
    u_2=u_2./r_2;
    E_2=SlopelimitN(E_2,ELim);
end
end

function [r_3,u_3, E_3 ] = RK_Third_Order_Euler(r,u,E,rLim,uLim,ELim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
   Globals1D;        
 ParametersPhysic;
   
   
r_1=zeros(P+1,N);
u_1=zeros(P+1,N);
E_1=zeros(P+1,N);
r_2=zeros(P+1,N);
u_2=zeros(P+1,N);
E_2=zeros(P+1,N);
r_3=zeros(P+1,N);
u_3=zeros(P+1,N);
E_3=zeros(P+1,N);

flux_r=zeros(P+1,N);
flux_ru=zeros(P+1,N);
flux_E=zeros(P+1,N);

[rLim, uLim, ELim]=BC_Euler(r,u,E);
[flux_r, flux_ru, flux_E]=Solvers_Euler(r,u,E,rLim,uLim,ELim);
 
  
r_1=r+dt*flux_r;
u_1=r.*u+dt*flux_ru;
u_1=u_1./r_1;

E_1=E+dt*flux_E;

[rLim, uLim, ELim]=BC_Euler(r_1,u_1,E_1);
if(slope == 1) 
    u_1=SlopelimitN(r_1.*u_1,rLim.*uLim );
    r_1=SlopelimitN(r_1,rLim);
    u_1=u_1./r_1;
    E_1=SlopelimitN(E_1,ELim);
end
[flux_r, flux_ru, flux_E]=Solvers_Euler(r_1,u_1,E_1,rLim,uLim,ELim);
 
  
r_2=0.25*(3*r+r_1+dt*flux_r);
u_2=0.25*(3*r.*u+r_1.*u_1+dt*flux_ru);
u_2=u_2./r_2;

E_2=0.25*(3*E+E_1+dt*flux_E);



[rLim, uLim, ELim]=BC_Euler(r_2,u_2,E_2);
if(slope == 1) 
    u_2=SlopelimitN(r_2.*u_2,rLim.*uLim );
    r_2=SlopelimitN(r_2,rLim);
    u_2=u_2./r_2;
    E_2=SlopelimitN(E_2,ELim);
end

[flux_r, flux_ru, flux_E]=Solvers_Euler(r_2,u_2,E_2,rLim,uLim,ELim);
 
  
r_3=(1/3)*(r+2*r_2+2*dt*flux_r);
u_3=(1/3)*(r.*u+2*r_2.*u_2+2*dt*flux_ru);
u_3=u_3./r_3;

E_3=(1/3)*(E+2*E_2+2*dt*flux_E);
[rLim, uLim, ELim]=BC_Euler(r_3,u_3,E_3);

if(slope == 1) 
    u_3=SlopelimitN(r_3.*u_3,rLim.*uLim );
    r_3=SlopelimitN(r_3,rLim);
    u_3=u_3./r_3;
    E_3=SlopelimitN(E_3,ELim);
end

end
