function [E_final,B_final ] = RK_solving_Maxwell(E,B,ELim,BLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
Globals1D;
ParametersPhysic;

E_final=zeros(P+1,N);
B_final=zeros(P+1,N);
RK_total_step=P+1;
switch RK_total_step
    case 1, [E_final,B_final ]=RK_First_Order_Maxwell(E,B,ELim,BLim,dt);
    case 2, [E_final,B_final ]=RK_Second_Order_Maxwell(E,B,ELim,BLim,dt);
    case 3, [E_final,B_final ]=RK_Third_Order_Maxwell(E,B,ELim,BLim,dt);   
    otherwise [E_final,B_final ]=RK_Third_Order_Maxwell(E,B,ELim,BLim,dt);  
end


end

function [E_1,B_1 ] = RK_First_Order_Maxwell(E,B,ELim,BLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;  
 ParametersPhysic;
 
E_1=zeros(P+1,N);
B_1=zeros(P+1,N);
flux_E=zeros(P+1,N);
flux_B=zeros(P+1,N);

[ELim, BLim]=BC_Maxwell(E,B);
[flux_E, flux_B]=Solvers_Maxwell(E,B,ELim,BLim); 
 
  
E_1=E+dt*flux_E;
B_1=B+dt*flux_B;

end

function [E_2,B_2 ] = RK_Second_Order_Maxwell(E,B,ELim,BLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;
 ParametersPhysic;
 
E_1=zeros(P+1,N);
B_1=zeros(P+1,N);
E_2=zeros(P+1,N);
B_2=zeros(P+1,N);

flux_E=zeros(P+1,N);
flux_B=zeros(P+1,N);

[ELim, BLim]=BC_Maxwell(E,B);
[flux_E, flux_B]=Solvers_Maxwell(E,B,ELim,BLim); 
 
  
E_1=E+dt*flux_E;
B_1=B+dt*flux_B;

[ELim, BLim]=BC_Maxwell(E_1,B_1);
if(slope == 1) 
    E_1=SlopelimitN(E_1,ELim);
    B_1=SlopelimitN(B_1,BLim);
end


[flux_E, flux_B]=Solvers_Maxwell(E_1,B_1,ELim,BLim); 
 
  
E_2=0.5*(E+E_1)+0.5*dt*flux_E;
B_2=0.5*(B+B_1)+0.5*dt*flux_B;

[ELim, BLim]=BC_Maxwell(E_2,B_2);
if(slope == 1) 
    E_2=SlopelimitN(E_2,ELim);
    B_2=SlopelimitN(B_2,BLim);
end

end

function [E_3,B_3 ] = RK_Third_Order_Maxwell(E,B,ELim,BLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
  Globals1D; 
  ParametersPhysic;
  
E_1=zeros(P+1,N);
B_1=zeros(P+1,N);
E_2=zeros(P+1,N);
B_2=zeros(P+1,N);
E_3=zeros(P+1,N);
B_3=zeros(P+1,N);

flux_E=zeros(P+1,N);
flux_B=zeros(P+1,N);

[ELim, BLim]=BC_Maxwell(E,B);
[flux_E, flux_B]=Solvers_Maxwell(E,B,ELim,BLim); 
 
  
E_1=E+dt*flux_E;
B_1=B+dt*flux_B;

[ELim, BLim]=BC_Maxwell(E_1,B_1);
if(slope == 1 ) 
    E_1=SlopelimitN(E_1,ELim);
    B_1=SlopelimitN(B_1,BLim);
end

[flux_E, flux_B]=Solvers_Maxwell(E_1,B_1,ELim,BLim); 
 
  
E_2=0.25*(3*E+E_1+dt*flux_E);
B_2=0.25*(3*B+B_1+dt*flux_B);

[ELim, BLim]=BC_Maxwell(E_2,B_2);
if(slope == 1) 
    E_2=SlopelimitN(E_2,Elim);
    B_2=SlopelimitN(B_2,BLim);
end

[flux_E, flux_B]=Solvers_Maxwell(E_2,B_2,ELim,BLim); 
 
  
E_3=(1/3)*(E+2*E_2+2*dt*flux_E);
B_3=(1/3)*(B+2*B_2+2*dt*flux_B);

[ELim, BLim]=BC_Maxwell(E_3,B_3);
if(slope == 1) 
    E_3=SlopelimitN(E_3,ELim);
    B_3=SlopelimitN(B_3,BLim);
end

end
