function [E_final,F_final ] = RK_solving_P1(E,F,S_E,S_F,ELim,FLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
Globals1D;
ParametersPhysic;

E_final=zeros(P+1,N);
F_final=zeros(P+1,N);
if(Time_scheme == 1) 
    RK_total_step=P+1;
switch RK_total_step
    case 1, [E_final,F_final ]=RK_First_Order_P1(E,F,S_E,S_F,ELim,FLim,dt);
    case 2, [E_final,F_final ]=RK_Second_Order_P1(E,F,S_E,S_F,ELim,FLim,dt);
    case 3, [E_final,F_final ]=RK_Third_Order_P1(E,F,S_E,S_F,ELim,FLim,dt);   
    otherwise [E_final,F_final ]=RK_Third_Order_P1(E,F,S_E,S_F,ELim,FLim,dt);  
end
elseif (Time_scheme ==2)
    RK_total_step=1;
 switch RK_total_step
    case 1, [E_final,F_final ]=IMEX_First_Order_P1(E,F,S_E,S_F,ELim,FLim,dt);
    case 2, [E_final,F_final ]=IMEX_First_Order_P1(E,F,S_E,S_F,ELim,FLim,dt);
    case 3, [E_final,F_final ]=IMEX_First_Order_P1(E,F,S_E,S_F,ELim,FLim,dt);   
    otherwise [E_final,F_final ]=IMEX_First_Order_P1(E,F,S_E,S_F,ELim,FLim,dt);  
            
 end   
else 
   RK_total_step=1;
 switch RK_total_step
    case 1, [E_final,F_final ]=PC_First_Order_P1(E,F,S_E,S_F,ELim,FLim,dt);
    case 2, [E_final,F_final ]=PC_First_Order_P1(E,F,S_E,S_F,ELim,FLim,dt);
    case 3, [E_final,F_final ]=PC_First_Order_P1(E,F,S_E,S_F,ELim,FLim,dt);   
    otherwise [E_final,F_final ]=PC_First_Order_P1(E,F,S_E,S_F,ELim,FLim,dt); 
    
 end
end 

end

function [E_1,F_1 ] = RK_First_Order_P1(E,F,S_E,S_F,ELim,FLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;  
 ParametersPhysic;
 
E_1=zeros(P+1,N);
F_1=zeros(P+1,N);
flux_E=zeros(P+1,N);
flux_F=zeros(P+1,N);

[ELim, FLim]=BC_P1(E,F);
[flux_E, flux_F]=Solvers_P1(E,F,ELim,FLim); 
 
  
E_1=E+dt*(flux_E+S_E);
F_1=F+dt*(flux_F+S_F);

end

function [E_2,F_2 ] = RK_Second_Order_P1(E,F,S_E,S_F,ELim,FLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;
 ParametersPhysic;
 
E_1=zeros(P+1,N);
F_1=zeros(P+1,N);
E_2=zeros(P+1,N);
F_2=zeros(P+1,N);

flux_E=zeros(P+1,N);
flux_F=zeros(P+1,N);

[ELim, FLim]=BC_P1(E,F);
[flux_E, flux_F]=Solvers_P1(E,F,ELim,FLim); 
 
  
E_1=E+dt*(flux_E+S_E);
F_1=F+dt*(flux_F+S_F);

[ELim, FLim]=BC_P1(E_1,F_1);
if(slope == 1) 
    E_1=SlopelimitN(E_1,ELim);
    F_1=SlopelimitN(F_1,FLim);
end


[flux_E, flux_F]=Solvers_P1(E_1,F_1,ELim,FLim); 
 
  
E_2=0.5*(E+E_1)+0.5*dt*(flux_E+S_E);
F_2=0.5*(F+F_1)+0.5*dt*(flux_F+S_F);

[ELim, FLim]=BC_P1(E_2,F_2);
if(slope == 1) 
    E_2=SlopelimitN(E_2,ELim);
    F_2=SlopelimitN(F_2,FLim);
end

end

function [E_3,F_3 ] = RK_Third_Order_P1(E,F,S_E,S_F,ELim,FLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
  Globals1D; 
  ParametersPhysic;
  
E_1=zeros(P+1,N);
F_1=zeros(P+1,N);
E_2=zeros(P+1,N);
F_2=zeros(P+1,N);
E_3=zeros(P+1,N);
F_3=zeros(P+1,N);

flux_E=zeros(P+1,N);
flux_F=zeros(P+1,N);

[ELim, FLim]=BC_P1(E,F);
[flux_E, flux_F]=Solvers_P1(E,F,ELim,FLim); 
 
  
E_1=E+dt*(flux_E+S_E);
E_1=F+dt*(flux_F+S_F);

[ELim, FLim]=BC_P1(E_1,F_1);
if(slope == 1 ) 
    E_1=SlopelimitN(E_1,ELim);
    F_1=SlopelimitN(F_1,FLim);
end

[flux_E, flux_F]=Solvers_P1(E_1,F_1,ELim,FLim); 
 
  
E_2=0.25*(3*E+E_1+dt*(flux_E+S_E));
F_2=0.25*(3*F+F_1+dt*(flux_F+S_F));

[ELim, FLim]=BC_P1(E_2,F_2);
if(slope == 1) 
    E_2=SlopelimitN(E_2,Elim);
    F_2=SlopelimitN(F_2,FLim);
end

[flux_E, flux_F]=Solvers_P1(E_2,F_2,ELim,FLim); 
 
  
E_3=(1/3)*(E+2*E_2+2*dt*(flux_E+S_E));
F_3=(1/3)*(F+2*F_2+2*dt*(flux_F+S_F));

[ELim, FLim]=BC_P1(E_3,F_3);
if(slope == 1) 
    E_3=SlopelimitN(E_3,ELim);
    F_3=SlopelimitN(F_3,FLim);
end

end

function [E_1,F_1 ] = IMEX_First_Order_P1(E,F,S_E,S_F,ELim,FLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;  
 ParametersPhysic;
 
E_1=zeros(P+1,N);
F_1=zeros(P+1,N);
flux_E=zeros(P+1,N);
flux_F=zeros(P+1,N);

[ELim, FLim]=BC_P1(E,F);
[flux_E, flux_F]=Solvers_P1(E,F,ELim,FLim); 
 
  
E_1=E+dt*(flux_E);
F_1=F+dt*(flux_F);

[E_1,F_1]=Local_implicit_P1(E_1,F_1,dt);
end


function [E_2,F_2 ] = PC_First_Order_P1(E,F,S_E,S_F,ELim,FLim,dt)
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;  
 ParametersPhysic;
 
E_1=zeros(P+1,N);
F_1=zeros(P+1,N);
E_2=zeros(P+1,N);
F_2=zeros(P+1,N);
flux_E=zeros(P+1,N);
flux_F=zeros(P+1,N);

[ELim, FLim]=BC_P1(E,F);
[flux_E, flux_F]=Solvers_P1(E,F,ELim,FLim); 
 
  
E_1=E+0.5*dt*(flux_E);
F_1=F+0.5*dt*(flux_F);

[E_1,F_1]=Local_implicit_P1(E_1,F_1,0.5*dt);

[ELim, FLim]=BC_P1(E_1,F_1);
[flux_E, flux_F]=Solvers_P1(E_1,F_1,ELim,FLim); 

E_2=E+dt*(flux_E);
F_2=F+dt*(flux_F);

[E_2,F_2]=Local_implicit_P1(E_2,F_2,dt);
end

