function [ r_temp, ru_temp, E_temp ] = Solvers_Euler(r,u,E,rLim,uLim,ELim)
%UNTITLED17 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D; 
   ParametersPhysic;

 
 F_rj=zeros(P+1,N);
 F_ruj=zeros(P+1,N);
 F_Ej=zeros(P+1,N);
 pj=zeros(P+1,1); 
 
 
 r_temp=zeros(P+1,N);
 ru_temp=zeros(P+1,N);
 E_temp=zeros(P+1,N);
 

 
 for j = 1 : 1 : N   
  
    xD=Nodes(j+1);
    xG=Nodes(j);
    
    rj=r(:,j);
    uj=u(:,j);
    Ej=E(:,j);
    
    pj = Pressure(rj,uj,Ej);

    cj=gammaEuler*pj(:)./rj(:);
    cj=sqrt(cj(:));
    
    
    F_rj=rj(:).*uj(:);
    F_ruj=rj(:).*uj(:).*uj(:)+pj(:);
    F_Ej=uj(:).*Ej(:)+pj(:).*uj(:);
    
    if( j == 1)
        rjm= rLim(:,1); 
        ujm= uLim(:,1);
        Ejm= ELim(:,1);
              
    else    
        rjm=r(:,j-1);
        ujm=u(:,j-1);
        Ejm=E(:,j-1);
        
    end     
    if( j == N)
        rjp= rLim(:,2); 
        ujp= uLim(:,2);
        Ejp= ELim(:,2);
    else    
        rjp=r(:,j+1);
        ujp=u(:,j+1);
        Ejp=E(:,j+1);
    end 
    pjm = Pressure(rjm,ujm,Ejm);
    cjm=gammaEuler*pjm(:)./rjm(:);
    cjm=sqrt(cjm(:));
    
    pjp = Pressure(rjp,ujp,Ejp);
    cjp=gammaEuler*pjp(:)./rjp(:);
    cjp=sqrt(cjp(:));
    
    F_rjm=rjm(:).*ujm(:);
    F_rujm=rjm(:).*ujm(:).*ujm(:)+pjm(:);
    F_Ejm=ujm(:).*Ejm(:)+pjm(:).*ujm(:);
    S_m=max(max(abs(ujm(:))+cjm(:)),max(abs(uj(:))+cj(:)));

    
    F_rjp=rjp(:).*ujp(:);
    F_rujp=rjp(:).*ujp(:).*ujp(:)+pjp(:);
    F_Ejp=ujp(:).*Ejp(:)+pjp(:).*ujp(:);
    S_p=max(max(abs(ujp(:))+cjp(:)),max(abs(uj(:))+cj(:)));
       
    
    if(scheme ==1)
      [Fr_p,Fru_p, FE_p] = flux_Rusanov(j,1,xD,rj,rjp,uj,ujp,Ej,Ejp,F_rj,F_rjp,F_ruj,F_rujp,F_Ej,F_Ejp,S_p);
      [Fr_m,Fru_m, FE_m] = flux_Rusanov(j,-1,xG,rjm,rj,ujm,uj,Ejm,Ej,F_rjm,F_rj,F_rujm,F_ruj,F_Ejm,F_Ej,S_m);
    
    end 
    

    r_temp(:,j)=- (InvM(:,:,j)) *( - D(:,:,j) * F_rj + Fr_p-Fr_m);
    ru_temp(:,j)=- (InvM(:,:,j)) *( - D(:,:,j) * F_ruj + Fru_p-Fru_m);
    E_temp(:,j)=- (InvM(:,:,j)) *( - D(:,:,j) * F_Ej + FE_p-FE_m);
 end

end 


function [F_r, F_ru, F_E] = flux_Rusanov(j,i,x,rG,rD,uG,uD,EG,ED, F_rG, F_rD,F_ruG, F_ruD, F_EG, F_ED,S)
%UNTITLED17 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;

Kp  = eye(P+1);
Km  = eye(P+1);

F_r=zeros(1,P+1);
F_ru=zeros(1,P+1);
F_E=zeros(1,P+1);


for m = 1 : 1 : P+1
    for l = 1: 1 : P+1
     if(i == 1)    
        Kp(m,l)=Basis_functions(l,1,j+1,x)*Basis_functions(m,1,j,x);   
        Km(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);
     end
     if(i == -1)    
        Kp(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);   
        Km(m,l)=Basis_functions(l,1,j-1,x)*Basis_functions(m,1,j,x);
     end
    end
end  


F_r = 0.5 * ( Kp * F_rD+ Km * F_rG ) + S * 0.5 * ( Km * rG -Kp * rD);
F_ru = 0.5 * ( Kp * F_ruD+ Km * F_ruG ) + S * 0.5 * ( Km * (rG.*uG) -Kp * (rD.*uD));
F_E = 0.5 * ( Kp * F_ED+ Km * F_EG ) + S * 0.5 * ( Km * EG -Kp *ED); 
 
end 

function pj = Pressure(rj,uj,Ej)
%UNTITLED17 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;
  ParametersPhysic;
 
 pj=zeros(P+1,1);
 pj(:)=(gammaEuler-1)*(Ej(:)-0.5*rj(:).*uj(:).*uj(:));

end






