function [ E_temp, B_temp ] = Solvers_Maxwell(E,B,ELim,BLim)
%UNTITLED17 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;
ParametersPhysic;
 
 E_temp=zeros(P+1,N);
 B_temp=zeros(P+1,N);
 
 
 for j = 1 : 1 : N 
  
    xD=Nodes(j+1);
    xG=Nodes(j);
    
    Ej=E(:,j);
    Bj=B(:,j);
    if( j == 1)
        Ejm= ELim(:,1); 
        Bjm= BLim(:,1);
    else    
        Ejm=E(:,j-1);
        Bjm=B(:,j-1);
    end     
    if( j == N)
        Ejp= ELim(:,2); 
        Bjp=BLim(:,2);
    else    
        Ejp=E(:,j+1);
        Bjp=B(:,j+1);
    end 
       
    
    if(scheme ==1)
      FEp = flux_upwind(j,1,xD,Bj,Bjp,Ej,Ejp);
      FEm = flux_upwind(j,-1,xG,Bjm,Bj,Ejm,Ej);
      FBp = flux_upwind(j,1,xD,Ej,Ejp,Bj,Bjp);
      FBm = flux_upwind(j,-1,xG,Ejm,Ej,Bjm,Bj);
    end 
    
    if(scheme ==2)
      FEp = flux_centered(j,1,xD,Bj,Bjp);
      FEm = flux_centered(j,-1,xG,Bjm,Bj);
      FBp = flux_centered(j,1,xD,Ej,Ejp);
      FBm = flux_centered(j,-1,xG,Ejm,Ej);
    end  

    E_temp(:,j)=- (InvM(:,:,j)) *( - c* D(:,:,j) * Bj + FEp-FEm);
    B_temp(:,j)=- (InvM(:,:,j)) *( - c* D(:,:,j) * Ej + FBp-FBm);
 end

end 


function F = flux_upwind(j,i,x,uG,uD,vG,vD)
%UNTITLED17 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;
 ParametersPhysic;
 
Kp  = eye(P+1);
Km  = eye(P+1);
F = zeros(P+1,1);
for m = 1 : 1 : P+1
    for l = 1: 1 : P+1
     if(i == 1)    
        Kp(m,l)=Basis_functions(l,1,j+1,x)*Basis_functions(m,1,j,x);   
        Km(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);
     end
     if(i == -1)    
        Kp(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);   
        Km(m,l)=Basis_functions(l,1,j-1,x)*Basis_functions(m,1,j,x);
     end
    end
end  

F = c * 0.5 * ( Kp * uD+ Km * uG ) + abs(c) * 0.5 * ( Km * vG -Kp * vD);
end 

function F = flux_centered(j,i,x,uG,uD)
%UNTITLED17 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;
ParametersPhysic;


Kp  = eye(P+1);
Km  = eye(P+1);
F = zeros(P+1,1);
for m = 1 : 1 : P+1
    for l = 1: 1 : P+1
     if(i == 1)    
        Kp(m,l)=Basis_functions(l,1,j+1,x)*Basis_functions(m,1,j,x);   
        Km(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);
     end
     if(i == -1)    
        Kp(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);   
        Km(m,l)=Basis_functions(l,1,j-1,x)*Basis_functions(m,1,j,x);
     end
    end
end  

F = c * 0.5 * ( Kp * uD+ Km * uG );

end 
