function [ E_temp, F_temp ] = Solvers_P1(E,F,ELim,FLim)
%UNTITLED17 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;
ParametersPhysic;
 
 E_temp=zeros(P+1,N);
 F_temp=zeros(P+1,N);
 
 
 for j = 1 : 1 : N 
  
    xD=Nodes(j+1);
    xG=Nodes(j);
    
    Ej=E(:,j);
    Fj=F(:,j);
    if( j == 1)
        Ejm= ELim(:,1); 
        Fjm= FLim(:,1);
    else    
        Ejm=E(:,j-1);
        Fjm=F(:,j-1);
    end     
    if( j == N)
        Ejp= ELim(:,2); 
        Fjp=FLim(:,2);
    else    
        Ejp=E(:,j+1);
        Fjp=F(:,j+1);
    end 
       
    
    if(scheme ==1)
      FEp = flux_upwind(j,1,xD,Fj,Fjp,Ej,Ejp);
      FEm = flux_upwind(j,-1,xG,Fjm,Fj,Ejm,Ej);
      FFp = flux_upwind(j,1,xD,Ej,Ejp,Fj,Fjp);
      FFm = flux_upwind(j,-1,xG,Ejm,Ej,Fjm,Fj);
    end 
    
    if(scheme ==2)
      FEp = flux_centered(j,1,xD,Fj,Fjp);
      FEm = flux_centered(j,-1,xG,Fjm,Fj);
      FFp = flux_centered(j,1,xD,Ej,Ejp);
      FFm = flux_centered(j,-1,xG,Ejm,Ej);
    end  
    epsilon_j=min(t_eps(:,j));
    
    
    E_temp(:,j)=- (InvM(:,:,j)) *( - (1./epsilon_j).* D(:,:,j) * Fj + (1./epsilon_j).* (FEp-FEm));
    F_temp(:,j)=- (InvM(:,:,j)) *( - (1./epsilon_j).* D(:,:,j) * Ej + (1./epsilon_j).* (FFp-FFm));
 end

end 


function F = flux_upwind(j,i,x,uG,uD,vG,vD)
%UNTITLED17 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;
 ParametersPhysic;
 
Kp  = eye(P+1);
Km  = eye(P+1);
F = zeros(P+1,1);
for m = 1 : 1 : P+1
    for l = 1: 1 : P+1
     if(i == 1)    
        Kp(m,l)=Basis_functions(l,1,j+1,x)*Basis_functions(m,1,j,x);   
        Km(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);
     end
     if(i == -1)    
        Kp(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);   
        Km(m,l)=Basis_functions(l,1,j-1,x)*Basis_functions(m,1,j,x);
     end
    end
end  

F =  0.5 * ( Kp * uD+ Km * uG ) + 0.5 * ( Km * vG -Kp * vD);
end 

function F = flux_centered(j,i,x,uG,uD)
%UNTITLED17 Summary of this function goes here
%   Detailed explanation goes here
 Globals1D;
ParametersPhysic;


Kp  = eye(P+1);
Km  = eye(P+1);
F = zeros(P+1,1);
for m = 1 : 1 : P+1
    for l = 1: 1 : P+1
     if(i == 1)    
        Kp(m,l)=Basis_functions(l,1,j+1,x)*Basis_functions(m,1,j,x);   
        Km(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);
     end
     if(i == -1)    
        Kp(m,l)=Basis_functions(l,1,j,x)*Basis_functions(m,1,j,x);   
        Km(m,l)=Basis_functions(l,1,j-1,x)*Basis_functions(m,1,j,x);
     end
    end
end  

F = 0.5 * ( Kp * uD+ Km * uG );

end 