function [r, u, E] = init_datas_Euler()
%UNTITLED8 Summary of this function goes here
%   Detailed explanation goes here
Globals1D;
 ParametersPhysic;

if(test ==1 ) 
    for k = 1 : 1 : P+1
        for j = 1 : 1 : N
            r(k,j) = 1;
            u(k,j) = 1;
            E(k,j) = 1;
        end
    end
end

if(test ==2 ) 
    for k = 1 : 1 : P+1
        for j= 1 : 1 : N
            xj = Degrees_freedom(k,j);
            r(k,j) = 1+0.99*sin(xj*pi);
            u(k,j) = 1;
            E(k,j) = 1/(gammaEuler-1) + 0.5*r(k,j)*u(k,j)*u(k,j);
        end
    end
end

if(test ==3 ) 
    for k = 1 : 1 : P+1
        for j = 1 : 1 : N
        xj = Degrees_freedom(k,j);
        
        if(xj <= 0.5* (LD+LG))
            r(k,j)=1;
            u(k,j)=0;
            E(k,j)=1/(gammaEuler-1) + 0.5*r(k,j)*u(k,j)*u(k,j);
        end
        if(xj > 0.5* (LD+LG))
            r(k,j)=0.125;
            u(k,j)=0;
            E(k,j)=0.1/(gammaEuler-1) + 0.5*r(k,j)*u(k,j)*u(k,j);
        end
        
        end
    end
end


if(test ==4 ) 
rhoL=1;
rhoR=0.125;
mu2= (gammaEuler-1)/(gammaEuler +1);
pL=1;
pR=0.1;

cL=sqrt(gammaEuler*pL/rhoL);
cR=sqrt(gammaEuler*pR/rhoR);

pm=bisect(pR,pL,0.0000000000001,gammaEuler,pL,pR,cL,cR);

rhomL=rhoL*(pm/pL)^(1/gammaEuler);

um= 2*cL/(gammaEuler-1)*(1-(pm/pL)^((gammaEuler-1)/(2*gammaEuler)));

rhomR= rhoR*((pm+mu2*pR)/(pR+mu2*pm));

us=um/(1-rhoR/rhomR);

ut=cL-um/(1-mu2);
    t=0.1;
    for k = 1 : 1 : P+1
        for j = 1 : 1 : N
            %xj = -LD +2*Degrees_freedom(k,j);
             xj = Degrees_freedom(k,j);
            if(xj<= -cL*t)
                r(k,j) = rhoL;
                u(k,j) = 0;
                E(k,j) = pL/(gammaEuler-1) + 0.5*r(k,j)*u(k,j)*u(k,j);     
            elseif(xj<= -ut*t)
                r(k,j) = rhoL *(-mu2* (xj/(cL *t))+(1-mu2))^(2/(gammaEuler-1));
                u(k,j) = (1-mu2)*(xj/t+cL);
                E(k,j) = (pL *(-mu2* (xj/(cL *t))+(1-mu2))^((2*gammaEuler)/(gammaEuler-1)))/(gammaEuler-1);
                E(k,j) = E(k,j)+0.5*r(k,j)*u(k,j)*u(k,j);     
            elseif(xj<= um*t)
                r(k,j) = rhomL;
                u(k,j) = um; %(1-mu2)*(xj/t+cL);
                E(k,j) = pm/(gammaEuler-1);%(pL *(-mu2* (xj/(cL *t))+(1-mu2))^((2*gamma)/(gamma-1)))/(gamma-1);
                E(k,j) = E(k,j)+ 0.5*r(k,j)*u(k,j)*u(k,j);  
            elseif(xj <= us*t)   
                r(k,j) = rhomR;
                u(k,j) = um;
                E(k,j) = pm/(gammaEuler-1);
                E(k,j) = E(k,j)+ 0.5*r(k,j)*u(k,j)*u(k,j);
            else
                r(k,j) = rhoR;
                u(k,j) = 0;
                E(k,j) = pR/(gammaEuler-1);
                E(k,j) = E(k,j)+ 0.5*r(k,j)*u(k,j)*u(k,j);
            end     
            
        end
    end
end
end


function pp = func_pressure(pm,gammaE,pL,pR,cL,cR)

pp=0;
mu2= (gammaE-1)/(gammaE +1);

pp1=-2*cL*(1-(pm/pL)^((-1+gammaE)/(2*gammaE)))/(cR*(-1+gammaE));
pp2=(-1+pm/pR)*((1-mu2)/(gammaE*(mu2+pm/pR)))^0.5;

pp=pp1+pp2;

end


function xb = bisect(a,b,tol,gamma,pL,pR,cL,cR)
% Matlab function bisect.m
% Solves f(x) = 0 using the bisection method
%
% Inputs:
% a = left endpoint of interval
% b = right endpoint of interval
% tol = tolerance for stopping bisection method
%
% Required m-file:
% f.m is m-file for function f(x)
% Outputs:
% Root by bisection
%
%
it=0;
err=0;
% set iteration count to zero
fa=func_pressure(a,gammaE,pL,pR,cL,cR);
fb=func_pressure(b,gammaE,pL,pR,cL,cR);
%
% check bracketing
%
if sign(fa)==sign(fb), error('Root not in bracket'); end
%
% begin while loop
%
while (b-a)>tol
    it=it+1;
    c=a+0.5*(b-a);
    fc=func_pressure(c,gammaE,pL,pR,cL,cR);
    if sign(fa)~=sign(fc); 
        b=c;
        fb=fc;
    else % root lies in [c,b]
        a=c;
        fa=fc;
    end
% print progress
xb=0.5*(a+b);
err=0.5*abs(b-a);
%fprintf('\n n = %i Solution = %15.10e error = %15.10e\n',it,xb, err);
% The pause command causes the execution of this routine to
% be paused at the end of each iteration. Press any key
% on the keyboard to continue.
end
end